{
  ho scritto questa piccola Unit per gestire le descript.ion di 4dos...
ehm, in realta' e' solo una bozza... pero' funge.

Al piu' presto ne faro' una versione migliore...
Certo che se la migliorasse qualcuno di voi, non mi offenderei :-)))
E' composta di due procedure:
1) descrivi    (descrive un file)
2) toglidesc   (toglie la descrizione ad un file)

ricordatevi, se dovete cancellare un file, di togliergli anche la descrizione...
altrimenti lasciate il DESCRIPT.ION zozzo... :-)
}

unit describe;  { aggiorna il DESCRIPT.ION v1.0 20/12/93 }

Interface

uses dos;
procedure descrivi( cammino, nomefile, info: string );
          { cammino e' il path dove trovasi il file da descrivere }
          { nomefile e' il nome del file (ma va' ?!) }
          { info e' la descrizione, limitata a 255 caratteri }

procedure toglidesc( cammino, nomefile: string );
          { toglidesc serve per togliere la descrizione ad un file }
          { naturalmente ha bisogno solo di 'cammino' e 'nomefile' }
          { e non anche di 'info' }

Implementation

{ function che trasforma in maiuscolo una stringa }
function maiusc( frase: string ): string;
var i: byte;
begin
  if length( frase )>0 then
    begin
      for i:=1 to length( frase ) do
        frase[i]:=UpCase(frase[i]);
      maiusc:=frase;
    end
  else
    maiusc:='';
end;

procedure descrivi( cammino, nomefile, info: string );
var desc: text;        { handle per il descript.ion }
    oldattr: word;     { per conservare gli attributi del descript.ion }
begin
  assign( desc, cammino+'descript.ion' );
  {$I-}
  reset(desc);
  {$I+}
  if ioresult<>0 then            { se non trova il file, lo crea }
    begin
      rewrite( desc );
      setfattr(desc, archive);
    end
  else                           { se lo trova...}
    begin
      getfattr( desc, oldattr);  { si conserva gli attributi }
      setfattr(desc, archive);
      close(desc);
      append( desc );
    end;

  { scrive la descrizione nel descript.ion }
  writeln(desc, nomefile, ' ',info);

  flush(desc);
  close(desc);
  setfattr(desc, oldattr);  { ripristina i vecchi attributi }
end;

procedure toglidesc( cammino, nomefile: string );
var desc, bak: text;
    temp: string;
    oldattr: word;
begin
  nomefile:=maiusc(nomefile)+' ';
  assign( desc, cammino+'descript.ion' );
  {$I-}
  reset(desc);
  {$I+}
  if IOresult=0 then
  { ci interessa solo il caso in cui il descript.ion esiste }
    begin
      getfattr(desc, oldattr);  { conserva gli attributi }
      assign( bak, cammino+'descript.bak');
      rewrite(bak);
      while not eof( desc ) do
        begin
          { copia il descript.ion in descript.bak, saltando la riga }
          { che ci interessa }
          readln(desc, temp);
          if pos(nomefile, maiusc(temp) )<>1 then
             writeln( bak, temp);
        end;
      { poi sostituisce il .bak al .ion }
      close(bak);
      close(desc);
      erase(desc);
      rename(bak, cammino+ 'descript.ion');
      setfattr(bak, oldattr);
    end;
end;

end.

